-- name: [CS] King Dedede's Dream Friends!
-- description: King Dedede and his pals know a thing or two about stars!\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local globalModName = "King Dedede's Dream Friends!"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_KIRBY_MODEL = smlua_model_util_get_id("kirby_geo") -- Located in "actors"
local E_MKNIGHT_MODEL = smlua_model_util_get_id("metaknight_geo") -- Located in "actors"
local E_WADDLEDEE_MODEL = smlua_model_util_get_id("waddledee_geo") -- Located in "actors"
local E_SUSIE_MODEL = smlua_model_util_get_id("susie_geo") -- Located in "actors"
local E_ADO_MODEL = smlua_model_util_get_id("ado_geo") -- Located in "actors"
local E_MODEL_MARX_MODEL = smlua_model_util_get_id("marx_geo") -- Located in "actors"
local E_DEDEDE_MODEL = smlua_model_util_get_id("dedede_geo") -- Located in "actors"

local TEX_KIRBY_LIFE_ICON = get_texture_info("kirby_icon") -- Located in "textures"
local TEX_MKNIGHT_LIFE_ICON = get_texture_info("mknight_icon") -- Located in "textures"
local TEX_WADDLEDEE_LIFE_ICON = get_texture_info("waddledee_icon") -- Located in "textures"
local TEX_SUSIE_LIFE_ICON = get_texture_info("susie_icon") -- Located in "textures"
local TEX_ADO_LIFE_ICON = get_texture_info("ado_icon") -- Located in "textures"
local TEX_MARX_LIFE_ICON = get_texture_info("marx_icon") -- Located in "textures"
local TEX_DEDEDE_LIFE_ICON = get_texture_info("dedede_icon") -- Located in "textures"

local VOICETABLE_KIRBY = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'kirby_startlevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'kirby_startlevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'kirby_jump1.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump1.ogg', 'kirby_doublejump.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'kirby_startlevel.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'kirby_grabitem.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'kirby_falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'kirby_doublejump.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'kirby_grabitem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'kirby_getstar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'kirby_throwbowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'kirby_damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'kirby_falling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'kirby_cough.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'kirby_cough.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_DEDEDE = {
	--[CHAR_SOUND_OKEY_DOKEY] = 'I am a super star warrior.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Kick Kirby to the Curb.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'HAH.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Get Ready.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Gotcha.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'HAH.ogg', 'HAH.ogg', 'Yo.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Get Ready.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Outta My Way.ogg', 'Comin Atcha.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'AHHH.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Look at that Charisma.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Yo.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'AHHH.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Comin Atcha.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'HMM.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'I am a super star warrior.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Kick Kirby to the Curb.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Suffering.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'AHH Help Me.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'UGGGH.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'cough1.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'cough2.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Surely You Jestin.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Holy Calamari.ogg' -- Booted out of level
}

local VOICETABLE_MKNIGHT = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'MK_GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'MK_GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'MK_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'MK_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'MK_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MK_TripleJump1.ogg', 'MK_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'MK_Damaged.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'MK_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'MK_GrabLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'MK_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'MK_TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'MK_GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'MK_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'MK_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'MK_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'MK_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'MK_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'MK_Tired.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'MK_Tired.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'MK_LeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_WADDLEDEE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Jump2.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Jump2.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Jump2.ogg', 'Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump1.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'GrabLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dee_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Punch2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Jump2.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Bonk.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Burned.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_SUSIE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Susie_GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Susie_GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump1.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Susie_LongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Susie_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Susie_GetStar.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Susie_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Susie_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_ADO = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump1.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_MARX = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Marx_StartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Marx_StartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Marx_TripleJump1.ogg', 'Marx_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Marx_StartLevel.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Marx_Laugh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Marx_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Marx_Laugh.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Marx_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Marx_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Marx_Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Marx_Laugh.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Marx_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Marx_Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Tired.ogg' -- Booted out of level
}

local CAPTABLE_MARX = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_WADDLEDEE = {
    normal = smlua_model_util_get_id("deenormal_geo"),
    wing = smlua_model_util_get_id("deewing_geo"),
    metal = smlua_model_util_get_id("deemetal_geo"),
}

local CAPTABLE_DEDEDE = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("dedede_metal_cap_geo"),
}

local CAPTABLE_ADO = {
    normal = smlua_model_util_get_id("adovanish_geo"),
    wing = smlua_model_util_get_id("adowing_geo"),
    metal = smlua_model_util_get_id("adometal_geo"),
}

local CAPTABLE_SUSIE = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_KIRBY = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_MKNIGHT = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local PALETTE_KIRBY = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "CB0800",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FFA1D6",
    [CAP]    = "FFA1D6",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_DEDEDE = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "FF0007",
    [GLOVES] = "ffffff",
    [SHOES]  = "FFA800",
    [HAIR]   = "FFA800",
    [SKIN]   = "0098FF",
    [CAP]    = "FF0007",
	[EMBLEM] = "FFA800",
}

local PALETTE_MKNIGHT = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FF91FF",
    [GLOVES] = "91928D",
    [SHOES]  = "FF40BD",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "0006CB",
    [CAP]    = "FFFFFF",
    [EMBLEM]  = "8A00DC",
}

local PALETTE_WADDLEDEE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FF4B2F",
    [CAP]    = "183094",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_SUSIE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FE55FF",
    [SKIN]   = "FFFFFF",
    [CAP]    = "FE55FF",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_ADO = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "24D974",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "723F31",
    [HAIR]   = "000000",
    [SKIN]   = "FEC179",
    [CAP]    = "FF2300",
    [EMBLEM]  = "1FA7FF",
}

local PALETTE_MARX = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "C22242",
    [GLOVES] = "ffffff",
    [SHOES]  = "721600",
    [HAIR]   = "ffffff",
    [SKIN]   = "CF66C0",
    [CAP]    = "FF0004",
	[EMBLEM] = "4843FF"
}

local CSloaded = false
local function on_character_select_load()
	
	CT_DEDEDE = _G.charSelect.character_add("King Dedede", {"The King of Dreamland is here...to help?", "Model from Kirby 64"}, "Garrulous64", {r = 255, g = 0, b = 0}, E_DEDEDE_MODEL, CT_DEDEDE, TEX_DEDEDE_LIFE_ICON)
    _G.charSelect.character_add_caps(E_DEDEDE_MODEL, CAPTABLE_DEDEDE)
    _G.charSelect.character_add_voice(E_DEDEDE_MODEL, VOICETABLE_DEDEDE)
    _G.charSelect.character_add_palette_preset(E_DEDEDE_MODEL, PALETTE_DEDEDE)

    CT_KIRBY = _G.charSelect.character_add("Kirby", {"Star Warrior of Planet Popstar!", ""}, "Garrulous64", {r = 255, g = 192, b = 203}, E_KIRBY_MODEL, CT_KIRBY, TEX_KIRBY_LIFE_ICON)
    _G.charSelect.character_add_voice(E_KIRBY_MODEL, VOICETABLE_KIRBY)
    _G.charSelect.character_add_palette_preset(E_KIRBY_MODEL, PALETTE_KIRBY)
	_G.charSelect.character_add_caps(E_KIRBY_MODEL, CAPTABLE_KIRBY)

    CT_MKNIGHT = _G.charSelect.character_add("Meta Knight", {"The Masked Mystery.", ""}, "Garrulous64", {r = 0, g = 0, b = 255}, E_MKNIGHT_MODEL, CT_MKNIGHT, TEX_MKNIGHT_LIFE_ICON)
    _G.charSelect.character_add_voice(E_MKNIGHT_MODEL, VOICETABLE_MKNIGHT)
    _G.charSelect.character_add_palette_preset(E_MKNIGHT_MODEL, PALETTE_MKNIGHT)
	_G.charSelect.character_add_caps(E_MKNIGHT_MODEL, CAPTABLE_MKNIGHT)

    CT_WADDLEDEE = _G.charSelect.character_add("Waddle Dee", {"The King's Right Hand.", ""}, "Garrulous64", {r = 150, g = 75, b = 0}, E_WADDLEDEE_MODEL, CT_WADDLEDEE, TEX_WADDLEDEE_LIFE_ICON)
    _G.charSelect.character_add_voice(E_WADDLEDEE_MODEL, VOICETABLE_WADDLEDEE)
	_G.charSelect.character_add_caps(E_WADDLEDEE_MODEL, CAPTABLE_WADDLEDEE)
    _G.charSelect.character_add_palette_preset(E_WADDLEDEE_MODEL, PALETTE_WADDLEDEE)

    CT_SUSIE = _G.charSelect.character_add("Susie Haltmann", {"Heir to the Haltmann Fortune.", ""}, "Garrulous64", {r = 255, g = 192, b = 203}, E_SUSIE_MODEL, CT_SUSIE, TEX_SUSIE_LIFE_ICON)
    _G.charSelect.character_add_voice(E_SUSIE_MODEL, VOICETABLE_SUSIE)
    _G.charSelect.character_add_palette_preset(E_SUSIE_MODEL, PALETTE_SUSIE)
	_G.charSelect.character_add_caps(E_SUSIE_MODEL, CAPTABLE_SUSIE)
	
	CT_ADO = _G.charSelect.character_add("Adeleine", {"The Lively Painter.", ""}, "Garrulous64", {r = 45, g = 255, b = 220}, E_ADO_MODEL, CT_ADO, TEX_ADO_LIFE_ICON)
    _G.charSelect.character_add_voice(E_ADO_MODEL, VOICETABLE_ADO)
    _G.charSelect.character_add_palette_preset(E_ADO_MODEL, PALETTE_ADO)
	_G.charSelect.character_add_caps(E_ADO_MODEL, CAPTABLE_ADO)
	
	CT_MARX = _G.charSelect.character_add("Marx", {"Mad, Malevolent Jester", ""}, "Garrulous64", {r = 171, g = 45, b = 255}, E_MODEL_MARX_MODEL, CT_MARX, TEX_MARX_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_MARX_MODEL, CAPTABLE_MARX)
    _G.charSelect.character_add_voice(E_MODEL_MARX_MODEL, VOICETABLE_MARX)
    _G.charSelect.character_add_palette_preset(E_MODEL_MARX_MODEL, PALETTE_MARX)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_KIRBY then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SUSIE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WADDLEDEE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MKNIGHT then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ADO then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MARX then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_KIRBY then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WADDLEDEE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MKNIGHT then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SUSIE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ADO then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MARX then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)